DECLARE FUNCTION TIMEFLAG# (DUMDATE AS ANY)
DECLARE FUNCTION TIMESTR$ (DUMDATE AS ANY)  'FRAC. OF DAY TO HR & MIN FRMT
DECLARE SUB DATEIN ()                       'GET START AND END DATES
DECLARE SUB INITDT ()                       'INITIALIZE DATES FROM TODAY
DECLARE SUB JDN2REC (DUMDATE AS ANY)        'CONFORM DATE RECORD TO JUL DAY #
DECLARE SUB MODSTRNG (X$)                   'MODIFIES STRING
DECLARE SUB STR2REC (DUMDATE AS ANY)        'CONFORM DATE RECORD TO STRING
DECLARE SUB YMD2REC (DUMDATE AS ANY)        'CONFORM DATE RECORD TO YR, MO, DA

DEFINT I-N
DEFDBL A-H, O-Z

'TFLAG = 0 FOR STANDARD TIME
'      = 1 FOR DAYLIGHT TIME
'      = 2 FOR 1ST  SUNDAY IN APR
'      = 3 FOR LAST SUNDAY IN OCT

'DATEPRCA - PROCEDURES FOR MANIPULATING DATES
'DATEPRCS WITH TFLAG ADDED 1999 OCT 05

  CONST DNOJ0G = 1721424.5#     '0001 JAN 0.0 - PROLEPTIC GREGORIAN CALENDAR
  CONST DNOJ0J = 1721422.5#     '0001 JAN 0.0 -           JULIAN    CALENDAR
  CONST DNOJ0T = 2415020#       '1900 JAN 0.5 -           GREGORIAN CALENDAR

  TYPE DATEREC
    YEAR AS INTEGER
    MO AS INTEGER
    DA AS INTEGER
    LPGR AS INTEGER
    DATESTR AS STRING * 11
    DNOJ AS DOUBLE
    DOW AS STRING * 2
    CLNDR AS STRING * 3
    TFLAG AS INTEGER
  END TYPE

  COMMON SHARED TT, TDATE$, STRDATE0 AS DATEREC, STRDATE AS DATEREC, ENDDATE AS DATEREC, STTDST, ITRULE
  COMMON SHARED HEADER$(), DFNAM$

  DIM SHARED MST(13)                     'DAYS ELAPSED AT START OF MONTH I
  DIM SHARED DANAM$(7)                   'NAMES OF DAYS OF WEEK
  DIM SHARED HEADER$(5)

  DATA 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365
  DATA "SU", "MO", "TU", "WE", "TH", "FR", "SA"

SUB DATEIN
  DO
    PRINT : PRINT
    PRINT SPC(15); "STARTING DATE ( YYYY/MM/DD) = ";
    CALL MODSTRNG(STRDATE0.DATESTR)
    STRDATE0.CLNDR = "XXX"
    CALL STR2REC(STRDATE0)
    PRINT : PRINT : PRINT
    ENDDATE.DATESTR = STRDATE0.DATESTR
    PRINT SPC(15); "ENDING   DATE ( YYYY/MM/DD) = ";
    CALL MODSTRNG(ENDDATE.DATESTR)
    ENDDATE.CLNDR = STRDATE0.CLNDR
    CALL STR2REC(ENDDATE)
    DIF = ENDDATE.DNOJ - STRDATE0.DNOJ
    IF (DIF < 0) THEN PRINT : PRINT SPC(15); "END BEFORE START - ENTER NEW DATES"
  LOOP UNTIL (DIF >= 0)
  STRDATE = STRDATE0
  IF (STRDATE.TFLAG = 1 OR STRDATE.TFLAG = 2) THEN STTDST = 1 ELSE STTDST = 0
  END SUB

SUB INITDT
  'INITIALIZE START AND END DATES AS TODAY & TODAY + 1 WEEK

  FOR I = 1 TO 13: READ MST(I): NEXT I

  FOR I = 1 TO 7: READ DANAM$(I): NEXT I

  TDATE$ = STRDATE0.DATESTR
  MID$(TDATE$, 1, 1) = " "
  MID$(TDATE$, 2, 4) = MID$(DATE$, 7, 4)
  MID$(TDATE$, 6, 1) = "/"
  MID$(TDATE$, 7, 5) = MID$(DATE$, 1, 5)
  MID$(TDATE$, 9, 1) = "/"

  STRDATE0.DATESTR = TDATE$
  STRDATE0.CLNDR = "XXX"
  CALL STR2REC(STRDATE0)
  ENDDATE.DATESTR = TDATE$
  ENDDATE.CLNDR = STRDATE0.CLNDR
  CALL STR2REC(ENDDATE)
  ENDDATE.DA = ENDDATE.DA + 6                'COMPUTE TO END WEEK
  CALL YMD2REC(ENDDATE)
  STRDATE = STRDATE0
END SUB

SUB JDN2REC (DUMDATE AS DATEREC)
  'CREATES DATE RECORD FROM JULIAN DAY NUMBER

  IF (DUMDATE.CLNDR <> "GRG" AND DUMDATE.CLNDR <> "JUL") THEN
   IF (DUMDATE.DNOJ < 2299160.5#) THEN DUMDATE.CLNDR = "JUL" ELSE DUMDATE.CLNDR = "GRG"
  END IF

  SELECT CASE DUMDATE.CLNDR
    CASE "GRG"
      'COMPUTE REMAINDERS AFTER 0001 JAN 01 (DNOJ0G = 0001 JAN 00.0 GRG)
      NCYC = INT((DUMDATE.DNOJ - DNOJ0G - 1) / 146097) 'GREGORIAN CYCLES OF 400 YRS
      DARM = DUMDATE.DNOJ - DNOJ0G - 1 - 146097 * NCYC
      NCEN = INT(DARM / 36524)                        'CENTURIES
      IF (NCEN = 4) THEN NCEN = 3                     'LAST DAY OF CYCLE
      DARM = DARM - 36524 * NCEN
      NQAD = INT(DARM / 1461)                         'QUADRENNIAL CYCLES
      DARM = DARM - 1461# * NQAD
      NYRS = INT(DARM / 365)                          'YEARS
      IF (NYRS = 4) THEN NYRS = 3                     'LAST DAY OF CYCLE
      DARM = DARM - 365 * NYRS
      DUMDATE.YEAR = 1 + 400 * NCYC + 100 * NCEN + 4 * NQAD + NYRS

      IF (NYRS = 3) THEN                              'TEST FOR LEAP YEAR
        IF (NCEN = 3) THEN
          DUMDATE.LPGR = 1
        ELSEIF (NQAD = 24) THEN
          DUMDATE.LPGR = 0
        ELSE DUMDATE.LPGR = 1
        END IF
      ELSE DUMDATE.LPGR = 0
      END IF
   
    CASE "JUL"
      'COMPUTE REMAINDERS AFTER 0001 JAN 01 (DNOJ0J = 0001 JAN 00.0 JUL)
      NCYC = INT((DUMDATE.DNOJ - DNOJ0J - 1) / 146100) 'JULIAN CYCLES OF 400 YRS
      DARM = DUMDATE.DNOJ - DNOJ0J - 1 - 146100 * NCYC
      NCEN = INT(DARM / 36525)                        'CENTURIES
      IF (NCEN = 4) THEN NCEN = 3                     'LAST DAY OF CYCLE
      DARM = DARM - 36525 * NCEN
      NQAD = INT(DARM / 1461)                         'QUADRENNIAL CYCLES
      DARM = DARM - 1461# * NQAD
      NYRS = INT(DARM / 365)                          'YEARS
      IF (NYRS = 4) THEN NYRS = 3                     'LAST DAY OF CYCLE
      DARM = DARM - 365 * NYRS
      DUMDATE.YEAR = 1 + 400 * NCYC + 100 * NCEN + 4 * NQAD + NYRS

      IF (NYRS = 3) THEN                              'TEST FOR LEAP YEAR
        DUMDATE.LPGR = 1
      ELSE DUMDATE.LPGR = 0
      END IF
  
  END SELECT
 
  MOX = 0                                         'FIND MONTH, DAY
  DO
    MOX = MOX + 1
    MSX = MST(MOX + 1)
    IF (MOX > 1) THEN MSX = MSX + DUMDATE.LPGR
  LOOP UNTIL (MSX > DARM)
  DUMDATE.MO = MOX
  DUMDATE.DA = INT(DARM - MST(MOX) + 1)
  IF (MOX > 2) THEN DUMDATE.DA = DUMDATE.DA - DUMDATE.LPGR

  XX = LEN(STR$(DUMDATE.YEAR))
  IF (XX >= 5) THEN
    MID$(DUMDATE.DATESTR, 1, 5) = RIGHT$(STR$(DUMDATE.YEAR), 5)
  ELSE
    MID$(DUMDATE.DATESTR, 1, 5) = SPACE$(5 - XX) + RIGHT$(STR$(DUMDATE.YEAR), XX)
  END IF
  MID$(DUMDATE.DATESTR, 6, 1) = "/"
  MID$(DUMDATE.DATESTR, 7, 2) = RIGHT$(STR$(DUMDATE.MO), 2)
  IF (MID$(DUMDATE.DATESTR, 7, 1) = " ") THEN MID$(DUMDATE.DATESTR, 7, 1) = "0"
  MID$(DUMDATE.DATESTR, 9, 1) = "/"
  MID$(DUMDATE.DATESTR, 10, 2) = RIGHT$(STR$(DUMDATE.DA), 2)
  IF (MID$(DUMDATE.DATESTR, 10, 1) = " ") THEN MID$(DUMDATE.DATESTR, 10, 1) = "0"

  XDOW = FIX(DUMDATE.DNOJ + 1.5#)
  NDOW = XDOW - 7# * FIX(XDOW / 7#) + 1#       'NUMBER OF DAY-OF-WEEK, SUN=1
  DUMDATE.DOW = DANAM$(NDOW)

  DUMDATE.TFLAG = TIMEFLAG(DUMDATE)
END SUB

SUB MODSTRNG (DUMSTR$)
  'MODIFIES STRING

   LSTR = LEN(DUMSTR$)
   CSRL0 = CSRLIN
   POS0 = POS(0)
   PRINT DUMSTR$;
   LOCATE CSRL0, POS0, 1
   L = 1                                        'CURSOR LOCATION IN STRING
   DO
     A$ = INKEY$
     WHILE (A$ = ""): A$ = INKEY$: WEND
     SELECT CASE ASC(A$)
     CASE 0
       SELECT CASE ASC(MID$(A$, 2, 1))
       CASE 71                                  'HOME
         L = 1
         LOCATE CSRLIN, POS0
       CASE 75                                  'LEFT ARROW
         IF (L > 1) THEN
           L = L - 1
           LOCATE CSRLIN, POS(1) - 1, 1
         END IF
       CASE 77                                  'RIGHT ARROW
         IF (L < LSTR) THEN
           L = L + 1
           LOCATE CSRLIN, POS(1) + 1, 1
         END IF
       CASE 79                                  'END
         L = LSTR
         LOCATE CSRLIN, POS0 + LSTR - 1
       CASE 82                                  'INSERT SPACE
         DUMSTR$ = DUMSTR$ + " "
         LSTR = LSTR + 1
         MID$(DUMSTR$, L + 1, LSTR - L) = MID$(DUMSTR$, L, LSTR - L)
         MID$(DUMSTR$, L, 1) = " "
         LOCATE CSRLIN, POS0
         PRINT DUMSTR$;
         LOCATE CSRLIN, POS0 + L - 1
       CASE 83                                  'DELETE
         IF LSTR > 1 THEN
           MID$(DUMSTR$, L, LSTR - L) = MID$(DUMSTR$, L + 1, LSTR - L)
           LSTR = LSTR - 1
           DUMSTR$ = LEFT$(DUMSTR$, LSTR)
           IF (L = LSTR + 1) THEN L = LSTR
           LOCATE CSRLIN, POS0
           PRINT DUMSTR$ + " ";
           LOCATE CSRLIN, POS0 + L - 1
         END IF
       END SELECT
     CASE 8                                     'BACKSPACE & DELETE
       IF (L > 1) THEN
         LOCATE CSRLIN, POS(1) - 1, 1
         PRINT " ";
         LOCATE CSRLIN, POS(1) - 1, 1
         L = L - 1
         MID$(DUMSTR$, L, 1) = " "
       END IF
     CASE 13                                    'ENTER
     CASE ELSE                                  'CHARACTER
       MID$(DUMSTR$, L, 1) = A$
       PRINT A$;
       IF (L < LSTR) THEN
         L = L + 1
       ELSE
         LOCATE CSRLIN, POS(1) - 1, 1
       END IF
     END SELECT
   LOOP UNTIL (ASC(A$) = 13)
   LOCATE CSRL0, POS0, 1

END SUB

SUB STR2REC (DUMDATE AS DATEREC)
  'CREATES RECORD BASED ON DATE STRING
  TSTR$ = LTRIM$(DUMDATE.DATESTR)                 'TEMP STRING W/0 L BLANKS
  N1 = INSTR(TSTR$, "/")
  IF (N1 = 0) THEN
    DUMDATE.YEAR = VAL(TSTR$)
    DUMDATE.MO = 0
    DUMDATE.DA = 0
  ELSE
    DUMDATE.YEAR = VAL(MID$(TSTR$, 1, N1 - 1))
    N2 = INSTR(N1 + 1, TSTR$, "/")
    IF (N2 = 0) THEN
      DUMDATE.MO = VAL(MID$(TSTR$, N1 + 1, LEN(TSTR$) - N1))
      DUMDATE.DA = 0
    ELSE
      DUMDATE.MO = VAL(MID$(TSTR$, N1 + 1, N2 - N1 - 1))
      DUMDATE.DA = VAL(MID$(TSTR$, N2 + 1, LEN(TSTR$) - N2))
    END IF
  END IF
  CALL YMD2REC(DUMDATE)
END SUB

FUNCTION TIMEFLAG (DUMDATE AS DATEREC)
'ADDED 1999 OCT 05 - DATEPRCA
'LAST MOD 1999 NOV 18

  MO = DUMDATE.MO
  DA = DUMDATE.DA
  XDOW = FIX(DUMDATE.DNOJ + 1.5#)
  NDOW = XDOW - 7# * FIX(XDOW / 7#) + 1#       'NUMBER OF DAY-OF-WEEK, SUN=1
  DASU = DA - (NDOW - 1)                       'DATE OF PRECEDING SUNDAY

  SELECT CASE MO
  
    CASE IS < 4
      TFLG = 0                                 'STANDARD TIME
 
    CASE IS = 4
      IF (DA > 7) THEN
        TFLG = 1                               'APR BEYOND 1ST WEEK
      ELSE
        IF (NDOW = 1) THEN
          TFLG = 2                             '1ST SUNDAY IN APR
        ELSE
          IF (DASU < 1) THEN
            TFLG = 0                           '1ST SUN APR NOT PASSED
          ELSE
            TFLG = 1                                 '1ST SUN APR PASSED
          END IF '(DASU)
        END IF '(NDOW)
      END IF '(DA)
 
    CASE IS < 10
      TFLG = 1                                       'DAYLIGHT TIME
 
    CASE IS = 10
      IF (DA < 25) THEN
        TFLG = 1                                     'OCT BEFORE LAST WEEK
      ELSE
        IF (NDOW = 1) THEN
          TFLG = 3                                   'LAST SUNDAY IN OCT
        ELSE
          IF (DASU < 25) THEN
            TFLG = 1                                 'LAST SUN OCT NOT PASSED
          ELSE
            TFLG = 0                                 'LAST SUN OCT PASSED
          END IF '(DASU)
        END IF '(NDOW)
      END IF '(DA)


    CASE IS > 10
      TFLG = 0                                       'STANDARD TIME
  
  END SELECT '(MO)
  TIMEFLAG = TFLG
END FUNCTION

FUNCTION TIMESTR$ (DUMDATE AS DATEREC)
  'CONVERTS FRACTION OF DAY TO HOUR & MINUTE FORMAT

  TPR = 24 * (DUMDATE.DNOJ + .5 - INT(DUMDATE.DNOJ + .5))

  TPH$ = STR$(INT(TPR)): TPM$ = STR$(INT(60 * (TPR - INT(TPR)) + .5))
  IF (LEN(TPH$) = 2) THEN TPH$ = "0" + RIGHT$(TPH$, 1) ELSE TPH$ = RIGHT$(TPH$, 2)
  IF (LEN(TPM$) = 2) THEN TPM$ = "0" + RIGHT$(TPM$, 1) ELSE TPM$ = RIGHT$(TPM$, 2)
  TIMESTR$ = TPH$ + TPM$

END FUNCTION

SUB YMD2REC (DUMDATE AS DATEREC)

  'COMPUTES JULIAN DAY NUMBER AND DATESTRING FROM REDUCED YEAR, MO, DA ------

  NY = INT((DUMDATE.MO - 1) / 12)               'REDUCE MONTHS 1 TO 12
  DUMDATE.YEAR = DUMDATE.YEAR + NY
  DUMDATE.MO = DUMDATE.MO - 12 * NY

  IF (DUMDATE.CLNDR <> "GRG" AND DUMDATE.CLNDR <> "JUL") THEN
    SELECT CASE DUMDATE.YEAR
      CASE IS < 1582
        DUMDATE.CLNDR = "JUL"
      CASE IS = 1582
        SELECT CASE DUMDATE.MO
          CASE IS < 10
            DUMDATE.CLNDR = "JUL"
          CASE IS = 10
            IF (DUMDATE.DA < 15) THEN DUMDATE.CLNDR = "JUL" ELSE DUMDATE.CLNDR = "GRG"
          CASE IS > 10
            DUMDATE.CLNDR = "GRG"
        END SELECT
      CASE IS > 1582
        DUMDATE.CLNDR = "GRG"
    END SELECT
  END IF

  SELECT CASE DUMDATE.CLNDR
    CASE "GRG"
      NCYC = INT((DUMDATE.YEAR - 1) / 400)          'GREGORIAN CYCLES OF 400 YRS
      NYRM1 = DUMDATE.YEAR - 1 - 400 * NCYC
      NCEN = INT(NYRM1 / 100)                       'CENTURIES
      NYRM2 = NYRM1 - 100 * NCEN
      NQAD = INT(NYRM2 / 4)                         'QUADRENNIAL CYCLES
      NYRM3 = NYRM2 - 4 * NQAD
      IF (NYRM1 = 399 OR (NYRM3 = 3 AND NYRM2 <> 99)) THEN DUMDATE.LPGR = 1 ELSE DUMDATE.LPGR = 0
      DUMDATE.DNOJ = DNOJ0G + 146097! * NCYC + 36524! * NCEN + 1461! * NQAD + 365! * NYRM3 + MST(DUMDATE.MO) + DUMDATE.DA
      IF (DUMDATE.MO > 2) THEN DUMDATE.DNOJ = DUMDATE.DNOJ + DUMDATE.LPGR
    CASE "JUL"
      NCYC = INT((DUMDATE.YEAR - 1) / 4)            'JULIAN CYCLES OF 4 YRS
      NYRM1 = DUMDATE.YEAR - 1 - 4 * NCYC
      IF (NYRM1 = 3) THEN DUMDATE.LPGR = 1 ELSE DUMDATE.LPGR = 0
      DUMDATE.DNOJ = DNOJ0J + 1461! * NCYC + 365! * NYRM1 + MST(DUMDATE.MO) + DUMDATE.DA
      IF (DUMDATE.MO > 2) THEN DUMDATE.DNOJ = DUMDATE.DNOJ + DUMDATE.LPGR
    END SELECT
    CALL JDN2REC(DUMDATE)

END SUB

