DECLARE SUB TTOGGLE (DUMDATE AS ANY, TPR#)
'$DYNAMIC
DECLARE FUNCTION ANGRDD# (X#)               'REDUCE ANGLES TO 0 TO 360
DECLARE FUNCTION ANGRDR# (X#)               'REDUCE ANGLES TO 0  TO 2*PI
DECLARE FUNCTION ATAN2# (S#, C#)            '2 ARGUMENT ARC TANGENT
DECLARE FUNCTION DELFRC# (X#)               'RETURNS 1,2 OR 5 * 10^N
DECLARE FUNCTION TIMESTR$ (DUMDATE AS ANY)  'FRAC. OF DAY TO HR & MIN FRMT
DECLARE SUB CONTUNTS ()                     'CONVERTS STANDARD <> DAYLIGHT T
DECLARE SUB CONVUNTS ()                     'CONVERTS BETWEEN ENG. & METRIC
DECLARE SUB DATEIN ()                       'GET START AND END DATES
DECLARE SUB DEFLSTA ()                      'SET DEFAULT STATION
DECLARE SUB EQUARG ()                       'UPDATE EQUILIB PHASE, NODE FACTS
DECLARE SUB FILEIN (NFIN%)                  'GET STATION FILE
DECLARE SUB FILEOUT ()                      'PUTS OUT STATION DATA FILE
DECLARE SUB HANDDH ()                       'COMPUTE HEIGHT/CURR & DERIVS
DECLARE SUB HHILLO ()                       'EXTREME HIGH, LOW & RANGE
DECLARE SUB HILO ()                         'COMPUTE HIGHS AND LOWS
DECLARE SUB HILOHDR ()
DECLARE SUB HILONEXT (KDRV%, KSLOPE%)       'FINDS NEXT EXTREMUM
DECLARE SUB HRLYHTS ()                      'COMPUTE HOURLY HEIGHTS/CURRENTS
DECLARE SUB HTDMND ()                       'COMPUTE HEIGHT/CURRENT ON DEMAND
DECLARE SUB INITDT ()                       'INITIALIZE DATES FROM TODAY
DECLARE SUB INITEL ()                       'INITIALIZE ELEMENT ARRAYS
DECLARE SUB JDN2REC (DUMDATE AS ANY)        'CONFORM DATE RECORD TO JUL DAY #
DECLARE SUB LISTIN ()                       'INPUT LIST OF STATIONS
DECLARE SUB MAKHDR ()                       'MAKE HEADER
DECLARE SUB MENU ()                         'MAIN MENU
DECLARE SUB MODSTRNG (X$)                   'MODIFIES STRING
DECLARE SUB OUTFILE ()                      'DEFINE FILE FOR PRINTED OUTPUT
DECLARE SUB PLOT2 ()                        'PLOT HEIGHTS/CURRENTS
DECLARE SUB PRASTRO ()                      'PRINT ASTRONOMICAL ARGUMENTS
DECLARE SUB PRCONST ()                      'PRINT CONSTITUENT FACTORS
DECLARE SUB PRNOTES ()                      'PRINT NOS, ETC. NOTES
DECLARE SUB PRTANDH (TX#, DUMDATE AS ANY, ITAHX%) 'PRINT TIME & HEIGHT/CURRENT
DECLARE SUB PRTHDR (ILN%, IPH%)
DECLARE SUB STR2REC (DUMDATE AS ANY)        'CONFORM DATE RECORD TO STRING
DECLARE SUB TCMAIN ()                       'CREATE DATA FILE
DECLARE SUB TITLSCRN ()                     'PRINT TITLE PAGE & WARNING
DECLARE SUB UPDATE ()                       'UPDATE ASTRONOMICAL ARGUMENTS
DECLARE SUB YMD2REC (DUMDATE AS ANY)        'CONFORM DATE RECORD TO YR, MO, DA

'TIDES4/4.07 ------------ TIDE PREDICTIONS -----------------------------------
'
'                         EDWARD P. WALLNER
'                        32 BARNEY HILL ROAD
'                       WAYLAND, MA 01778-3602
'                          (508)-358-7938
'
' BASICA      VERSION STARTED  1986 JUL 09
' QUICK BASIC VERSION STARTED  1989 AUG 23
' TIDES400    VERSION STARTED  1996 OCT 16
' TIDES407    VERSION STARTED  1999 NOV 05
' LAST MODIFICATION            2000 FEB 18
'
'BASED ON "MANUAL OF HARMONIC ANALYSIS AND PREDICTION OF TIDES",
'PAUL SCHUREMAN, U.S.GOVT. PRINTING OFFICE, WASHINGTON, 1941
'COAST AND GEODETIC SURVEY SPECIAL PUBLICATION NO. 98
'
'ASTRONOMICAL CONSTANTS TAKEN FROM "EXPLANATORY SUPPLEMENT TO THE
'ASTRONOMICAL EPHEMERIS ---", HER MAJESTY'S STATIONERY OFFICE, 1961
'
'NCON IS NUMBER OF CONSTITUENTS IN DATA SET
'JCON IS NUMBER OF THESE FOR STATION BEING CONSIDERED
'
'FIRST 37 CONSTITUENTS USED BY NOS TIDE PREDICTING MACHINE NO. 2
'NEXT  27 CONSTITUENTS USED BY IHO DATA BANK - 1988 DATA SUBMISSION FORM
'NEXT   4 CONSTITUENTS USED IN ANALES DEL INSTITUTO DE GEOFISICA
'NEXT   2 CONSTITUENTS USED IN GERMAN DATA
'
'M1 CONSTITUENT COMPUTED USING EQUATIONS (195), (196) AND (206)
'[TABLES 14 & 15 BASED ON ALTERNATE FORMULATION USING EQUATION (202)]
'
'MSf CONSTITUENT COMPUTED USING ARGUMENT AND NODE FACTOR FOR COMPOUND
'S2-M2 TIDE, NOT TABLE 2. SEE PAGE 48 OF MANUAL. (CHANGED 1992FEB08)
'
'FOR HYDRAULIC CURRENT STATIONS, CONSTITUENT AMPLITUDES ARE FOR SQUARE OF
'CURRENT IN KNOTS. SEE MANUAL, PARA. 437 ET SEQ.
'
'KTIDTYP = 0 FOR TIDAL HEIGHTS
'        = 1 FOR REVERSING CURRENT STATIONS
'        = 2 FOR HYDRAULIC CURRENT STATIONS
'        = 3 FOR ROTARY    CURRENT STATIONS
'
'HT(1) = HEIGHT OR CURRENT
'HT(2) = FIRST  DERIVATIVE
'HT(3) = SECOND DERIVATIVE
'HT(4) = DIRECTION OF ROTARY CURRENT
'
'TFLAG = 0 FOR STANDARD TIME
'      = 1 FOR DAYLIGHT TIME
'      = 2 FOR 1ST  SUNDAY IN APR
'      = 3 FOR LAST SUNDAY IN OCT
'
'ITRULE = 0 FOR STANDARD TIME
'       = 1 FOR U.S. DAYLIGHT RULES


'DIMENSIONS, AND CONSTANTS ---------------------------------------------
    
  DEFINT I-N: DEFDBL A-H, O-Z
    
  TYPE DATEREC
    YEAR AS INTEGER
    MO AS INTEGER
    DA AS INTEGER
    LPGR AS INTEGER
    DATESTR AS STRING * 11
    DNOJ AS DOUBLE
    DOW AS STRING * 2
    CLNDR AS STRING * 3
    TFLAG AS INTEGER
  END TYPE

  CONST PI = 3.141592653589793#, RDPD = PI / 180#, DGPR = 180# / PI
  CONST TWOPI = 2# * PI
  CONST NCON = 70              'NUMBER OF TIDAL CONSTITUENTS EXCLUDING Z0
  CONST KINFR = 16             'NUMBER OF POSSIBLE INFERRED CONSTITUENTS
  CONST DTMAX = 1#             'MAXIMUM TIME STEP IN HIGH/LOW SEARCH IN HOURS
 
  COMMON SHARED TT, TDATE$, STRDATE0 AS DATEREC, STRDATE AS DATEREC, ENDDATE AS DATEREC, STTDST, ITRULE
  COMMON SHARED HEADER$(), DFNAM$

  COMMON SHARED FLDAZ, EBBAZ, TZ, Z0, KTIDTYP, AMPLI(), EPCHM(), INDXHC(), TITLE$, UNITS$
  COMMON SHARED NAM$(), SPEED(), PARAMS$, XUNITS$, EXTREMA$, COMMENTS$
  COMMON SHARED JCON, SMAMP, HT(), IINFR(), NOTES$

  COMMON SHARED KSLOPE, KDRV, ITAH  'SLOPE AT LAST 0, DERIV TO MAKE 0, PRT OPT
  COMMON SHARED NEWDATE AS DATEREC

  'MISC
  DIM SHARED HEADER$(5), IINFR(KINFR)
  DIM SHARED NAM$(NCON), AMPLI(NCON), EPCHM(NCON), SPEED(NCON), INDXHC(NCON)
  DIM SHARED HT(4)
  DIM SHARED NHILO, IPR
  DIM SHARED FLAG1, FLAG2, FLAG3

'INITIALIZATION -------------------------------------------------------
  SCREEN 0, 0, 0: COLOR 14, 1, 1: KEY OFF
  CALL INITEL
  TDATE$ = RIGHT$(DATE$, 4) + "/" + MID$(DATE$, 1, 2) + "/" + MID$(DATE$, 4, 2)
  HEADER$(1) = STRING$(30, " ") + "TIDES407" + STRING$(25, " ") + TDATE$
  ITRULE = 2                                                  'U.S. RULE
  STTDST = 0                                                  'STANDARD TIME
  
'MAIN LOOP ==================================================================
  ON ERROR GOTO ERRHNDLR
  CALL TITLSCRN                         'PRINT TITLE SCREEN AND WARNING
  OPEN "LPT1" FOR APPEND AS #3          'OUTPUT FILE = PRINTER
  CALL INITDT                           'START TODAY, END NEXT WEEK
  CALL UPDATE                           'UPDATE ASTRONOMICAL ELEMENTS, ETC.
  CALL FILEIN(0)                        'GET DEFAULT STATION NAME
  IF (FLAG3 = 0) THEN                   'DEFAULT.TD4 EXISTS
    CALL EQUARG                         'EQUILIB. ARGS, SPEEDS & NODE FACTORS
  END IF

  DO
    CALL MENU
  LOOP

END '========================================================================
                                                  
ERRHNDLR: 'ERROR HANDLING SUBROUTINE ----------------------------------------

  IF (ERL = 1111) THEN
    FLAG1 = 1
    PRINT "STALIST.T&C FILE MISSING"
    RESUME NEXT
  ELSEIF (ERL = 2222) THEN
    FLAG2 = 1
    RESUME NEXT
  ELSEIF (ERL = 2224) THEN
    FLAG3 = 1
    PRINT : PRINT "FILE NOT FOUND - RETYPE";
    LOCATE CSRLIN - 1, 1
    RESUME NEXT
  ELSEIF (ERR = 25) THEN
    LOCATE 11, 19
    PRINT "CONNECT PRINTER AND PRESS ANY KEY"
    WHILE (INKEY$ = ""): WEND
    LOCATE 11, 19
    PRINT "                                  "
    LOCATE 3, 1
    RESUME
  ELSE
    END
  END IF

END 'TIDES407 ===============================================================

SUB CONTUNTS
  'SELECT RULE FOR STANDARD/DAYLIGHT SAVING TIME
  CALL PRTHDR(2, 0)

  PRINT "ITRULE = 0 -- STANDARD TIME"
  PRINT "       = 1 -- DAYLIGHT SAVING TIME"
  PRINT "       = 2 -- U.S. RULES"
  PRINT
  

  PRINT "(U.S.RULES: DAYLIGHT SAVING TIME IS IN EFFECT"
  PRINT " FROM O2OO STT (0300 DST) ON THE FIRST SUNDAY OF APRIL"
  PRINT " UNTIL 0200 DST (0100 STT) ON THE LAST SUNDAY OF OCTOBER"
  PRINT
  PRINT
  DO
    LOCATE CSRLIN - 1, 1
    INPUT "ITRULE = "; ITRULE
  LOOP UNTIL (ITRULE >= 0 AND ITRULE < 3)

  CALL MAKHDR
END SUB 'CONTUNITS ==========================================================

SUB CONVUNTS STATIC
  'CONVERTS UNITS BETWEEN ENGLISH AND METRIC
 
  HFAC = .3048#             'METERS PER FOOT

  IF (KTIDTYP = 0) THEN
    IF (UNITS$ = "METRIC") THEN
      UNITS$ = "ENGLISH"
      XUNITS$ = "FEET "
      HFAC = 1 / HFAC
      SOUND 300, 1: SOUND 0, 3: SOUND 400, 1
    ELSE
      UNITS$ = "METRIC"
      XUNITS$ = "M.   "
      SOUND 400, 1: SOUND 0, 3: SOUND 300, 1
    END IF
 
    Z0 = HFAC * Z0
    FOR J = 1 TO JCON
      I = INDXHC(J)
      AMPLI(I) = HFAC * AMPLI(I)
    NEXT J
    CALL EQUARG
  END IF
END SUB 'CONVUNITS ==========================================================

SUB DEFLSTA
  'CHANGE DEFAULT STATION
  CALL FILEIN(1)

  DFOUT$ = "DEFAULT.TD4"
 
  'READ OUT CONSTANTS FOR STATION ----------------------------------------

  OPEN DFOUT$ FOR OUTPUT AS #2
  PRINT #2, CHR$(34) + TITLE$ + CHR$(34)
  PRINT #2, CHR$(34) + NOTES$ + CHR$(34)
  PRINT #2, CHR$(34) + COMMENTS$ + CHR$(34)
  PRINT #2, USING "\     \ "; UNITS$;
  PRINT #2, USING "## "; KTIDTYP;
  PRINT #2, USING "### "; FLDAZ; EBBAZ;
  PRINT #2, USING "+##.## "; TZ
  PRINT #2, USING "Z0       ##.####"; Z0
  FOR J = 1 TO JCON
    I = INDXHC(J)
    IF (AMPLI(I) > 0) THEN
      PRINT #2, USING "\      \ "; NAM$(I);
      PRINT #2, USING "##.#### "; AMPLI(I);
      PRINT #2, USING "###.## "; EPCHM(I)
    END IF
  NEXT J
  CLOSE #2

  CALL EQUARG

END SUB 'DEFLSTA ============================================================

FUNCTION DELFRC (X)
  'SET LINE INCREMENT IN PLOTS ----------------------------------------------
  'SETS VALUE TO 1, 2 OR 5 * POWER OF TEN
 
  BLOGX = LOG(X) / LOG(10)                'COMMON LOG OF X
  FACTT = INT(BLOGX)                      'CHARACTERISTIC
  FACTX = 10 ^ (BLOGX - FACTT)            '1  FACTX < 10
  FACTT = 10 ^ FACTT                      'POWER OF TEN
  IF (FACTX < 2) THEN DEL = .2# ELSE IF (FACTX < 5) THEN DEL = .5# ELSE DEL = 1#
  DELFRC = FACTT * DEL
END FUNCTION 'DELFRC ========================================================

SUB FILEIN (NFIN)

  IF (NFIN = 0) THEN                                'FIRST CALL
    IF (COMMAND$ <> "") THEN DFNAM$ = COMMAND$ ELSE DFNAM$ = "DEFAULT.TD4"
   
    FLAG2 = 0
2222 : OPEN DFNAM$ FOR INPUT AS #2           'CHECK DEFAULT OR CMND LINE
2223 : 'DUMMY LINE TO RESET ERL
      IF (FLAG2 > 0) THEN                    'NO DEFAULT OR COMMAND LINE FILE
        CLS
        CALL PRTHDR(1, 0)
        LOCATE 12, 29
        PRINT "SELECT STATION"
        DFNAM$ = "XXXXXXXX.TD4                    " 'DUMMY NAME
        LOCATE 25, 24
        PRINT "PRESS ANY KEY TO CONTINUE";
        WHILE (INKEY$ = ""): WEND
      END IF '(FLAG2 > 0)
     
  END IF '(NFIN = 0)

  IF (NFIN + FLAG2 > 0) THEN                 'NOT FIRST CALL OR NO DEFAULT
    CALL LISTIN                              'PRINT STATION LIST (STALIST.T&C)
    LOCATE 25, 1: PRINT STRING$(79, " ");
    LOCATE 25, 20
    PRINT "ENTER DATA FILE NAME OR 'QQ' TO QUIT";
    DO
      LOCATE 23, 1
      PRINT STRING$(79, " ");
      LOCATE CSRLIN, 1
      PRINT "ENTER DATA FILE NAME - ";
      DFNAM$ = DFNAM$ + "              "      'PAD ON RIGHT FOR SHORT NAMES
      CALL MODSTRNG(DFNAM$)
      DFNAM$ = UCASE$(DFNAM$)
      IF (LEFT$(DFNAM$, 2) = "QQ") THEN EXIT SUB
     
      ISTART = 1                              'BACK UP DIRECTORY LEVEL?
      JSTART = INSTR(ISTART, DFNAM$, "..\")
      DO WHILE (JSTART > 0)
        ISTART = ISTART + 3
        JSTART = INSTR(ISTART, DFNAM$, "..\")
      LOOP
     
      DFNAM$ = LEFT$(DFNAM$, INSTR(ISTART, DFNAM$, ".") + 3)
      FLAG3 = 0
2224 : OPEN DFNAM$ FOR INPUT AS #2
2225 : 'DUMMY LINE TO RESET ERL
    LOOP UNTIL (FLAG3 = 0)
  END IF  '(NFIN + FLAG2 > 0)

  'READ IN CONSTANTS FOR STATION ----------------------------------------
  INPUT #2, TITLE$
  INPUT #2, NOTES$
  INPUT #2, COMMENTS$
  LINE INPUT #2, TEMP$
  K = INSTR(TEMP$, " ")                          'LOCATE FIRST BLANK
  UNITS$ = LEFT$(TEMP$, K - 1)
  KTIDTYP = VAL(MID$(TEMP$, 9, 2))
  FLDAZ = VAL(MID$(TEMP$, 12, 3))
  EBBAZ = VAL(MID$(TEMP$, 16, 3))
  TZ = VAL(MID$(TEMP$, 20, 6))
  LINE INPUT #2, TEMP$                           'Z0 LINE
  Z0 = VAL(MID$(TEMP$, 10, 7))
  JCON = 0
  DO WHILE (EOF(2) = 0)                          'OTHER CONSTITUENTS
    LINE INPUT #2, TEMP$
    K = INSTR(TEMP$, " ")                        'LOCATE FIRST BLANK
    IF (K > 1) THEN                              'LINE NOT BLANK
      NAMT$ = LEFT$(TEMP$, K - 1)
      AMPLIT = VAL(MID$(TEMP$, 10, 7))
      EPCHMT = VAL(MID$(TEMP$, 18, 6))
      FOR I = 1 TO NCON                            'SEARCH FOR NAME IN
        IF (NAM$(I) = NAMT$) THEN                  'CONSTITUENT SET
          JCON = JCON + 1
          INDXHC(JCON) = I
          AMPLI(I) = AMPLIT
          EPCHM(I) = EPCHMT
          EXIT FOR
        END IF
      NEXT I
    END IF
  LOOP

  CLOSE #2
  CALL MAKHDR
  IF (NFIN = 0) THEN CALL PRNOTES
 
END SUB 'FILEIN ========================================================

SUB HHILLO
  'SEARCHES FOR EXTREME HIGH, LOW AND RANGE OVER INTERVAL
  CLS
  CALL PRTHDR(4, 0)
  LOCATE 7, 1
  INPUT "PRINT RESULTS (Y/N) ? ", ANS$
  ANS$ = UCASE$(LEFT$(ANS$, 1))
  IF (ANS$ = "Y") THEN
    IPR = 2
    PRINT
    INPUT "PRINT EACH NEW EXTREME (Y/N) ?  ", ANSTOP$
    ANSTOP$ = UCASE$(LEFT$(ANSTOP$, 1))
'    IF (ANSTOP$ = "Y") THEN
'      PRINT "PRESS ANY KEY TO CONTINUE"
'    END IF
  ELSE
    IPR = 0
  END IF

  CLS
  CALL PRTHDR(4, IPR)
  LOCATE 7, 1
  PRINT "START DATE - "; STRDATE.DATESTR; "    END DATE - "; ENDDATE.DATESTR;
  IF (STRDATE.CLNDR = "JUL") THEN PRINT "   JULIAN CALENDAR" ELSE PRINT
  IF (IPR > 0) THEN
    PRINT #3, "START DATE - "; STRDATE.DATESTR; "    END DATE - "; ENDDATE.DATESTR;
    IF (STRDATE.CLNDR = "JUL") THEN PRINT #3, "   JULIAN CALENDAR" ELSE PRINT #3, ""
    PRINT #3, ""
  END IF
    
  LOCATE 25, 10
  PRINT "PRESS 'Q' TO STOP SEARCH";
 
  SELECT CASE KTIDTYP
  CASE IS = 0
    HGHFLD$ = "EXTREME HIGH  = "
    LOWEBB$ = "EXTREME LOW   = "
  CASE IS > 0
    HGHFLD$ = "EXTREME FLOOD = "
    LOWEBB$ = "EXTREME EBB   = "
  END SELECT
 
  NEWDATE = STRDATE
  TT = 0
  XHI = -99
  LOCATE 11, 1
  PRINT HGHFLD$; : PRINT USING "+##.##  "; XHI;
  PRINT USING "\       \"; XUNITS$;
  DATEHI$ = NEWDATE.DATESTR
  PRINT DATEHI$
  XLO = 99
  LOCATE 13, 1
  PRINT LOWEBB$; : PRINT USING "+##.##  "; XLO;
  PRINT USING "\       \"; XUNITS$;
  DATELO$ = NEWDATE.DATESTR
  PRINT DATELO$
  XRN = 0
  LOCATE 15, 1
  PRINT "EXTREME RANGE = "; : PRINT USING "+##.##  "; XRN;
  PRINT USING "\       \"; XUNITS$;
  DATERN$ = NEWDATE.DATESTR
  PRINT DATERN$
  LOCATE 18, 1
  PRINT "EXTREME RANGE COMPUTED BETWEEN CONSECUTIVE TIDES"

  'KDRV = 1 IF SEARCH FOR NULL OF HEIGHT/CURRENT    [TO BE USED FOR SLACK WATER]
  '     = 2 IF SEARCH FOR NULL OF FIRST DERIVATIVE  [USED FOR EXTREMA]

  KDRV = 2                                   'SEARCH FOR EXTREMA ONLY

  CALL HANDDH                            'EVALUATE HEIGHT AND DERIVATIVES
  IF ((KDRV = 1) AND (KTIDTYP = 2)) THEN HT(1) = SGN(HT(1)) * HT(1) ^ 2
  HTOLD = HT(1)
  KSLOPE = -SGN(HT(KDRV))                    'SLOPE OF HT(KDRV) @ NEXT ZERO
 
  DO                                         'START SEARCH FOR NEXT EXTREMUM
    CALL HILONEXT(2, KSLOPE)
    RNG = ABS(HT(1) - HTOLD)
    NEWDATE.DNOJ = STRDATE.DNOJ + TT / 24
    CALL JDN2REC(NEWDATE)

    LOCATE 9, 1
    PRINT "CHECKING "; NEWDATE.DATESTR
    HTOLD = HT(1)
   
    SELECT CASE HT(1)
    CASE IS > XHI
      XHI = HT(1)
      LOCATE 11, 1
      PRINT HGHFLD$; : PRINT USING "+##.##  "; XHI;
      PRINT USING "\       \"; XUNITS$;
      DATEHI$ = NEWDATE.DATESTR$ + "  " + TIMESTR$(NEWDATE)
      PRINT DATEHI$
      IF (ANSTOP$ = "Y") THEN
        PRINT #3, HGHFLD$; : PRINT #3, USING "+##.##  "; XHI;
        PRINT #3, USING "\       \"; XUNITS$;
        PRINT #3, DATEHI$
      END IF
    CASE IS < XLO
      XLO = HT(1)
      LOCATE 13, 1
      PRINT LOWEBB$; : PRINT USING "+##.##  "; XLO;
      PRINT USING "\       \"; XUNITS$;
      DATELO$ = NEWDATE.DATESTR$ + "  " + TIMESTR$(NEWDATE)
      PRINT DATELO$
      IF (ANSTOP$ = "Y") THEN
        PRINT #3, LOWEBB$; : PRINT #3, USING "+##.##  "; XLO;
        PRINT #3, USING "\       \"; XUNITS$;
        PRINT #3, DATELO$
      END IF
    END SELECT
    IF (RNG > XRN) THEN
      XRN = RNG
      LOCATE 15, 1
      PRINT "EXTREME RANGE = "; : PRINT USING "+##.##  "; XRN;
      PRINT USING "\       \"; XUNITS$;
      DATERN$ = NEWDATE.DATESTR$ + "  " + TIMESTR$(NEWDATE)
      PRINT DATERN$
      IF (ANSTOP$ = "Y") THEN
        PRINT #3, "EXTREME RANGE = "; : PRINT #3, USING "+##.##  "; XRN;
        PRINT #3, USING "\       \"; XUNITS$;
        PRINT #3, DATERN$
      END IF
    END IF

    KSLOPE = -KSLOPE                         'NEXT CROSSING OPPOSITE SLOPE
    IF (UCASE$(LEFT$(INKEY$, 1)) = "Q") THEN EXIT DO
  LOOP WHILE (NEWDATE.DNOJ < ENDDATE.DNOJ)
 
  IF (IPR > 0) THEN
    PRINT #3, ""
    PRINT #3, ""
    PRINT #3, HGHFLD$; : PRINT #3, USING "+##.##  "; XHI;
    PRINT #3, USING "\       \"; XUNITS$;
    PRINT #3, DATEHI$
    PRINT #3, ""
    PRINT #3, LOWEBB$; : PRINT #3, USING "+##.##  "; XLO;
    PRINT #3, USING "\       \"; XUNITS$;
    PRINT #3, DATELO$
    PRINT #3, ""
    PRINT #3, "EXTREME RANGE = "; : PRINT #3, USING "+##.##  "; XRN;
    PRINT #3, USING "\       \"; XUNITS$;
    PRINT #3, DATERN$
    PRINT #3, ""
    PRINT #3, ""
    PRINT #3, "EXTREME RANGE COMPUTED BETWEEN CONSECUTIVE TIDES"
    PRINT #3, CHR$(12)
  END IF

  LOCATE 25, 10
  PRINT "PRESS ANY KEY TO RETURN TO MENU";
  WHILE (INKEY$ = ""): WEND
                          
END SUB 'HHILLO ========================================================

SUB HILO
  'HIGHS AND LOWS ----------------------------------------------------
   
  'LAST MODIFIED 1993 MAY 04

  CALL HILOHDR

  NHILO = 0
  NLINES = 13
  NEWDATE = STRDATE
  TT = 0
  IF (ITAH < 2) THEN CALL PRTANDH(TT, NEWDATE, -1)

  'KDRV = 1 IF SEARCH FOR NULL OF HEIGHT/CURRENT   [USED FOR SLACK WATER]
  '     = 2 IF SEARCH FOR NULL OF FIRST DERIVATIVE [USED FOR EXTREMA]

  KDRV = 2                                      'SEARCH FOR EXTREMA ONLY

  CALL HANDDH                            'EVALUATE HEIGHT AND DERIVATIVES
  IF ((KDRV = 1) AND (KTIDTYP = 2)) THEN HT(1) = SGN(HT(1)) * HT(1) ^ 2

  KSLOPE = -SGN(HT(KDRV))                       'SLOPE OF HT(KDRV) @ NEXT ZERO

  DO                                            'START SEARCH FOR NEXT EXTREMUM
    CALL HILONEXT(KDRV, KSLOPE)

    CALL PRTANDH(TT, NEWDATE, ITAH)             'PRINT RESULTS
    IF (NHILO MOD 4 = 1) THEN                   'NEW LINE
      NLINES = NLINES + 1
      IF (IPR = 0 AND NLINES = 24) THEN         'CHECK FOR FULL SCREEN
        DO
          INK$ = INKEY$
        LOOP UNTIL (INK$ <> ""):
        IF (INK$ = "Q" OR ASC(INK$) = 27) THEN EXIT SUB
        NLINES = 4
      END IF
    END IF
   
    KSLOPE = -KSLOPE                            'NEXT CROSSING OPPOSITE SLOPE

    INK$ = INKEY$
    IF (UCASE$(INK$) = "Q") THEN EXIT SUB
 
  LOOP WHILE (TT < 24 * (ENDDATE.DNOJ - STRDATE.DNOJ + 1))
 
  IF (IPR > 0) THEN PRINT #3, CHR$(12)
  LOCATE 25, 1: PRINT SPC(79);
  LOCATE 25, 27: PRINT "PRESS ANY KEY TO CONTINUE.";
  WHILE (INKEY$ = ""): WEND
END SUB 'HILO ==========================================================

SUB HILOHDR
'HILO ROUTINE HEADER
  CLS
  CALL PRTHDR(4, 0)
  LOCATE 7, 1
  PRINT "START DATE - "; STRDATE.DATESTR; "    END DATE - "; ENDDATE.DATESTR;
  IF (STRDATE.CLNDR = "JUL") THEN PRINT "   JULIAN CALENDAR"
  LOCATE 11, 20
  PRINT "PRINT "; EXTREMA$; : INPUT ; " (Y/N) ?  ", ANS$
  ANS$ = UCASE$(LEFT$(ANS$, 1))
  IF (ANS$ = "Y") THEN IPR = 2 ELSE IPR = 0            '2 = SCREEN & PRINTER

  CLS
  LOCATE 25, 10: PRINT "TYPE 'Q' OR 'Esc' TO QUIT, ANY OTHER KEY TO CONTINUE."; : LOCATE 1, 1
  LOCATE 1, 1
  CALL PRTHDR(4, IPR)
  PRINT EXTREMA$; " IN "; XUNITS$
  PRINT
  IF (KTIDTYP = 0) THEN
    PRINT " YEAR MO DA        TIME  HT.      TIME  HT.      TIME  HT.      TIME  HT."
    PRINT "                   ";
    FOR I = 1 TO 4: PRINT "HHMM  "; XUNITS$; "    "; : NEXT I
    PRINT : PRINT
  ELSE
    PRINT " YEAR MO DA        TIME  CURR.    TIME  CURR.    TIME  CURR.    TIME  CURR."
    PRINT "                   ";
    FOR I = 1 TO 4: PRINT "HHMM  "; XUNITS$; "    "; : NEXT I
    PRINT : PRINT
  END IF
  IF (IPR > 0 AND ITAH < 2) THEN
    PRINT #3, EXTREMA$; " IN "; XUNITS$, CHR$(10), CHR$(10), CHR$(13)
    IF (KTIDTYP = 0) THEN
      PRINT #3, " YEAR MO DA        TIME  HT.      TIME  HT.      TIME  HT.      TIME  HT."
      PRINT #3, "                   ";
      FOR I = 1 TO 4: PRINT #3, "HHMM  "; XUNITS$; "    "; : NEXT I
      PRINT #3, CHR$(10), CHR$(13)
    ELSE
      PRINT #3, " YEAR MO DA        TIME  CURR.    TIME  CURR.    TIME  CURR.    TIME  CURR."
      PRINT #3, "                   ";
      FOR I = 1 TO 4: PRINT #3, "HHMM  "; XUNITS$; "    "; : NEXT I
      PRINT #3, CHR$(10), CHR$(13)
    END IF
  END IF
END SUB 'HILOHDR =======================================================

SUB HILONEXT (KDRV, KSLOPE)
    'FINDS NEXT ZERO CROSSING OF HEIGHT (KDRV=1) OR RATE (KDRV=2)
    'WITH SLOPE KSLOPE
   
    DT = 3 * DTMAX                           'SETUP FOR FIRST STEP OF +DTMAX
    TT = TT + DT                             'OVERRIDE FIRST BACKUP
    DO
      TT = TT - DT                           'BACK UP ONE STEP
      DT = DT / 3                            'CUT STEP SIZE
      TT = TT + DT
      CALL HANDDH                            'EVALUATE HEIGHT AND DERIVATIVES
      IF ((KDRV = 1) AND (KTIDTYP = 2)) THEN HT(1) = SGN(HT(1)) * HT(1) ^ 2
   
      WHILE (SGN(HT(KDRV)) = -KSLOPE)        'STEP UNTIL HT(KDRV) CHANGES SIGN
        TT = TT + DT
        CALL HANDDH                          'EVALUATE HEIGHT AND DERIVATIVES
        IF ((KDRV = 1) AND (KTIDTYP = 2)) THEN HT(1) = SGN(HT(1)) * HT(1) ^ 2
      WEND
  
    LOOP UNTIL (SGN(HT(KDRV + 1)) = KSLOPE)  'ASSURES NEWTON-RAPHSON WILL
                                             'BACK UP INTO REGION WITH NULL

    IF (HT(KDRV) = 0) THEN DT = 0            'ZERO ALREADY FOUND

    DXOLD = HT(KDRV)
    WHILE (ABS(DT) > .005)                   'LIMITED NEWTON-RAPHSON
      DTOLD = DT
      IF (HT(KDRV + 1) = 0) THEN
        DT = .6 * SGN(DXOLD / HT(KDRV)) * ABS(DT)  'HORIZONTAL INFLECTION
      ELSE
        DT = -HT(KDRV) / HT(KDRV + 1)
      END IF
      IF (ABS(DT) > .6 * ABS(DTOLD)) THEN DT = SGN(DT) * .6 * ABS(DTOLD)
      DXOLD = HT(KDRV)
      TT = TT + DT
      CALL HANDDH
      IF ((KDRV = 1) AND (KTIDTYP = 2)) THEN HT(1) = SGN(HT(1)) * HT(1) ^ 2
    WEND
    IF ((KDRV = 1) AND (KTIDTYP = 2)) THEN HT(1) = SGN(HT(1)) * SQR(ABS(HT(1)))

END SUB 'HILONEXT ======================================================

SUB HRLYHTS
  'HOURLY HEIGHTS -----------------------------------------------------------
  CLS
  CALL PRTHDR(4, 0)
  PRINT : PRINT
  PRINT SPC(15); "PRINT HOURLY "; PARAMS$; " (Y/N) ?  "; : INPUT "", ANS$
  ANS$ = UCASE$(LEFT$(ANS$, 1))
  IF (ANS$ = "Y") THEN IPR = 1 ELSE IPR = 0
 
  CLS
  LOCATE 25, 10: PRINT "TYPE 'Q' OR 'Esc' TO QUIT, ANY OTHER KEY TO CONTINUE."; : LOCATE 1, 1
  CALL PRTHDR(4, IPR)
  PRINT PARAMS$; " IN "; XUNITS$
  PRINT
 
  IF (ITAH < 2) THEN                        'MULTIPLE HEIGHTS PER LINE
    PRINT " YEAR MO DA";
    IF (IPR > 0) THEN
      PRINT #3, PARAMS$; " IN "; XUNITS$; , CHR$(10), CHR$(10), CHR$(10), CHR$(13)
      PRINT #3, " YEAR MO DA";
    END IF
   
    FOR I = 0 TO 3
      PRINT TAB(21); : IF (IPR = 1) THEN PRINT #3, TAB(21);
      FOR J = 0 TO 5
        PRINT USING "## HRS   "; 6 * I + J;
        IF (IPR = 1) THEN PRINT #3, USING "## HRS   "; 6 * I + J;
      NEXT J
    NEXT I
    PRINT : IF (IPR > 0) THEN PRINT #3, ""
  END IF

  NLINES = 15
  TT = 0
  NEWDATE = STRDATE
  IF (ITAH < 2) THEN
    PRINT : PRINT NEWDATE.DATESTR; " "; NEWDATE.DOW;              'PRINT DATE
    IF (IPR > 0) THEN PRINT #3, "": PRINT #3, NEWDATE.DATESTR; " "; NEWDATE.DOW; 'PRINT DATE
  END IF

  DO
    FOR ITT = 0 TO 3
      IF (ITAH < 2) THEN
        PRINT TAB(19);
        IF (IPR = 1) THEN PRINT #3, TAB(19);
      END IF
      FOR JTT = 0 TO 5
        CALL HANDDH                    'EVALUATE HEIGHT AND DERIVATIVE
        IF (ITAH < 2) THEN
          PRINT USING "####.#   "; HT(1);
          IF (IPR = 1) THEN PRINT #3, USING "####.#   "; HT(1);
        ELSE
          CALL PRTANDH(TT, NEWDATE, 2)
        END IF
        TT = TT + 1
      NEXT JTT
      NLINES = NLINES + 1
      IF (IPR = 0 AND NLINES = 24) THEN         'CHECK FOR FULL SCREEN
        DO
          INK$ = INKEY$
        LOOP UNTIL (INK$ <> "")
        INK$ = UCASE$(LEFT$(INK$, 1))
        IF (INK$ = "Q" OR ASC(INK$) = 27) THEN EXIT SUB
        NLINES = 6
      END IF
    NEXT ITT
    PRINT : IF (IPR = 1) THEN PRINT #3, ""
    NEWDATE.DA = NEWDATE.DA + 1                 'INCREMENT DAY OF YEAR & PRINT
    CALL YMD2REC(NEWDATE)
    IF (ITAH < 2) THEN
      PRINT : PRINT NEWDATE.DATESTR; " "; NEWDATE.DOW;             'PRINT DATE
      IF (IPR > 0) THEN PRINT #3, "": PRINT #3, NEWDATE.DATESTR; " "; NEWDATE.DOW; 'PRINT DATE
    END IF
  LOOP WHILE (TT < 24 * (ENDDATE.DNOJ - STRDATE.DNOJ + 1))
 
  IF (IPR = 1 AND ITAH < 2) THEN PRINT #3, CHR$(12)
  LOCATE 25, 1: PRINT SPC(79);
  LOCATE 25, 27: PRINT "PRESS ANY KEY TO CONTINUE.";
  WHILE (INKEY$ = ""): WEND

END SUB 'HRLYHTS =======================================================

SUB HTDMND
  'HEIGHTS/CURRENTS ON DEMAND -----------------------------------------------
  CLS
  CALL PRTHDR(4, 0)
  PRINT : PRINT
  PRINT SPC(15); "PRINT "; PARAMS$; " (Y/N) ?  "; : INPUT "", ANS$
  ANS$ = UCASE$(LEFT$(ANS$, 1))
  IF (ANS$ = "Y") THEN IPR = 1 ELSE IPR = 0
  PRINT
  PRINT SPC(15); "HEIGHT/CURRENT FOR SINGLE TIMES"
  PRINT SPC(15); "OR MULTIPLE TIMES AT FIXED INTERVALS (S/M) ? ";
  ANSSM$ = "S"
  CALL MODSTRNG(ANSSM$)
  ANSSM$ = UCASE$(LEFT$(ANSSM$, 1))
  PRINT
  IF (ANSSM$ = "Q" OR ASC(ANSSM$) = 27) THEN EXIT SUB
  IF (ANSSM$ = "M") THEN
    PRINT
    PRINT SPC(15);
    INPUT "INTERVAL IN MINUTES AND DECIMALS = ", DXMIN
    PRINT
    PRINT SPC(15);
    INPUT "NUMBER OF REPETITIONS            = ", IRPT
  END IF
  IF (IRPT < 1) THEN IRPT = 1

  CLS
  LOCATE 25, 19: PRINT "ENTER 'Q' OR 'Esc' TO PAUSE OR QUIT."; : LOCATE 1, 1
  CALL PRTHDR(4, IPR)
  PRINT PARAMS$; " IN "; XUNITS$
  PRINT
  PRINT : PRINT TAB(13); " YYYY/MM/DD/HHMM.MM"; TAB(36); "HT/CUR"; TAB(46); "RATE"; TAB(56); "ACCEL.": PRINT
  IF (IPR > 0) THEN
    PRINT #3, PARAMS$; " IN "; XUNITS$; CHR$(10), CHR$(10), CHR$(10), CHR$(13)
    PRINT #3, TAB(13); " YYYY/MM/DD/HHMM.MM"; TAB(36); "HT/CUR"; TAB(46); "RATE"; TAB(56); "ACCEL."; CHR$(10), CHR$(13)
  END IF

  DNEW$ = STRDATE.DATESTR + "/0000.00"
  DO                                               'COMPUTATION LOOP
    PRINT "DATE/TIME = ";
    CALL MODSTRNG(DNEW$)
    ANS$ = UCASE$(LEFT$(DNEW$, 1))
    IF (ANS$ = "Q" OR ASC(ANS$) = 27) THEN
      IF (IPR = 1) THEN PRINT #3, CHR$(12)
      EXIT SUB
    END IF
    NEWDATE.DATESTR = LEFT$(DNEW$, 11)
    NEWDATE.CLNDR = "XXX"
    CALL STR2REC(NEWDATE)
  
    IHRS = VAL(MID$(DNEW$, 13, 2))
    XMIN = VAL(MID$(DNEW$, 15, 5))

    FOR I = 1 TO IRPT                                          '
      PRINT TAB(13); DNEW$;                                    '
      TT = 24 * (NEWDATE.DNOJ - STRDATE.DNOJ) + IHRS + XMIN / 60
      CALL HANDDH
      PRINT TAB(36); : PRINT USING "###.##"; HT(1);
      PRINT TAB(44); : PRINT USING "###.###"; HT(2);
      PRINT TAB(54); : PRINT USING "###.###"; HT(3)
      IF (IPR > 0) THEN
        PRINT #3, "DATE/TIME = "; TAB(13); DNEW$;
        PRINT #3, TAB(36); : PRINT #3, USING "##.##"; HT(1);
        PRINT #3, TAB(44); : PRINT #3, USING "###.###"; HT(2);
        PRINT #3, TAB(54); : PRINT #3, USING "###.###"; HT(3)
      END IF

      IF (ANSSM$ = "M") THEN
        IDHR = 0
        XMIN = XMIN + DXMIN
        IF (XMIN >= 60) THEN
          IDHR = XMIN \ 60#
          XMIN = XMIN - 60# * IDHR
          IHRS = IHRS + IDHR
          IF (IHRS > 23) THEN
            IDDY = IHRS \ 24#
            NEWDATE.DA = NEWDATE.DA + IDDY
            CALL YMD2REC(NEWDATE)
            MID$(DNEW$, 1, 11) = NEWDATE.DATESTR
            IHRS = IHRS - IDDY * 24#
          END IF
        END IF                                   'END IF XMIN > 60
        IHRS$ = STR$(IHRS)
        MID$(IHRS$, 1, 1) = "0"
        IXMIN = 100# * XMIN
        IXMIN$ = STR$(IXMIN)
        L = LEN(IXMIN$) - 1
        IXMIN$ = STRING$(4 - L, "0") + RIGHT$(IXMIN$, L)
        MID$(DNEW$, 13, 2) = RIGHT$(IHRS$, 2)
        MID$(DNEW$, 15, 2) = LEFT$(IXMIN$, 2)
        MID$(DNEW$, 18, 2) = RIGHT$(IXMIN$, 2)
      END IF                                     'END IF M
      A$ = INKEY$
      IF (A$ <> "") THEN
        IF (ASC(A$) = 27 OR ASC(A$) = 81 OR ASC(A$) = 113) THEN EXIT FOR
      END IF
    NEXT I                                       'END IRPT LOOP
  LOOP                                           'END COMPUTATION LOOP

END SUB 'HTDMND ========================================================

SUB LISTIN
  CLS
  LOCATE 1, 1
  CALL PRTHDR(1, 0)
  FLAG1 = 0
  ANS$ = "R"
  DO WHILE (ANS$ = "R")
1111 : OPEN "STALIST.T&C" FOR INPUT AS #1  'READ IN LIST OF STATIONS
1112 : 'DUMMY LINE TO RESET ERL
    IF (FLAG1 <> 0) THEN EXIT SUB
    ANS$ = "M"
    DO WHILE (ANS$ = "M")
      CLS
      LOCATE 25, 2
      PRINT "PRESS 'M' FOR MORE, 'R' TO RESTART, 'S' TO STOP SEARCH, 'Q' OR 'Esc' TO QUIT";
      LOCATE 1, 1
      PRINT HEADER$(1)
      PRINT
      PRINT "        TIDAL CONSTANTS ARE STORED FOR THE FOLLOWING STATIONS:"
      PRINT "STATION"; TAB(64); "DATA FILE NAME"
      PRINT STRING$(79, "-")
      DO WHILE ((EOF(1) = 0) AND (CSRLIN < 21))
        INPUT #1, TITLE$
        PRINT TITLE$
      LOOP
      IF (EOF(1) = 0) THEN PRINT "----- MORE -----" ELSE PRINT "----- END -----"
     
      DO
        DO: ANS$ = UCASE$(INKEY$): LOOP WHILE (ANS$ = "")
        IF (ANS$ = "Q" OR ASC(ANS$) = 27) THEN CLOSE #1: EXIT SUB   'Esc=Q
        IF (ASC(ANS$) = 13) THEN ANS$ = "M"                         'CARR RET
      LOOP UNTIL ((ANS$ = "M") OR (ANS$ = "S") OR (ANS$ = "R"))
     
      IF ((ANS$ = "M") AND (EOF(1) <> 0)) THEN ANS$ = "R"
    LOOP ' CONTINUE LOOP
    CLOSE #1
    IF (ANS$ = "Q") THEN EXIT SUB
  LOOP ' RESTART LOOP
END SUB 'LISTIN ========================================================

SUB MAKHDR
  'MAKE HEADER ARRAY
  A$ = UCASE$(LEFT$(UNITS$, 1))
  IF (A$ = "M") THEN
    HUNITS$ = "M.   "
  ELSE
    HUNITS$ = "FEET "
  END IF
  VUNITS$ = "KNOTS"

  IF (KTIDTYP = 0) THEN
    PARAMS$ = "HEIGHTS": XUNITS$ = HUNITS$: EXTREMA$ = "HIGHS AND LOWS"
  ELSE
    PARAMS$ = "CURRENTS": XUNITS$ = VUNITS$: EXTREMA$ = "FLOODS(+) AND EBBS(-)"
  END IF

  HEADER$(2) = TITLE$
 
  ZT = STTDST - TZ                                      'DIFFERENCE FROM UT
  IF (ZT < 0) THEN UTDIF$ = " = UT -" ELSE UTDIF$ = " = UT +"
  UTDIF$ = UTDIF$ + STR$(ABS(ZT)) + " HOURS."
                                           
  SELECT CASE ITRULE
    CASE IS = 0
      TRULE$ = " - STANDARD TIME - FIXED"
    CASE IS = 1
      TRULE$ = " - DAYLIGHT SAVING TIME - FIXED"
    CASE IS = 2
      TRULE$ = " - U.S. DAYLIGHT SAVING TIME RULES"
  END SELECT
 
  IF (STTDST = 1) THEN
    HEADER$(3) = "LOCAL DAYLIGHT SAVING TIME" + UTDIF$ + TRULE$
  ELSE
    HEADER$(3) = "LOCAL STANDARD TIME" + UTDIF$ + TRULE$
  END IF
 
  IF (KTIDTYP > 0 AND KTIDTYP < 3) THEN
    HEADER$(4) = "DIRECTION AT FLOOD(+) =" + LEFT$(STR$(FLDAZ), 6) + ", AT EBB(-) =" + LEFT$(STR$(EBBAZ), 6) + ""
  ELSE
    HEADER$(4) = ""
  END IF 'KTIDTYP
END SUB 'MAKHDR ========================================================

SUB MENU
  'LAST MOD 1991 SEP 30
  DO
    CLS
    STRDATE = STRDATE0                   'RESTORE START DATE TO INPUT VALUE
    CALL JDN2REC(STRDATE)
    CALL UPDATE
    CALL EQUARG
    CALL PRTHDR(2, 0)
    IF (STRDATE.CLNDR = "GRG") THEN PRINT "        ";
    PRINT "     START: "; STRDATE.DATESTR; "   END: "; ENDDATE.DATESTR;
    IF (STRDATE.CLNDR = "JUL") THEN PRINT "   JULIAN CALENDAR" ELSE PRINT ""
    PRINT
    PRINT SPC(15); "A. COMPUTE "; EXTREMA$
    PRINT SPC(15); "B. COMPUTE HOURLY "; PARAMS$
    PRINT SPC(15); "C. PLOT "; PARAMS$
    PRINT SPC(15); "D. COMPUTE "; PARAMS$; " FOR GIVEN DATES AND TIMES"
    PRINT SPC(15); "E. CHANGE STATION"
    PRINT SPC(15); "F. CHANGE DATES"
    PRINT SPC(15); "G. CHANGE DEFAULT STATION"
    PRINT SPC(15); "H. CREATE DATA FILE FOR NEW STATION"
    SELECT CASE ITRULE
      CASE IS = 0
        PRINT SPC(15); "I. CHANGE TIME - STANDARD TIME TO DAYLIGHT OR U.S. RULES"
      CASE IS = 1
        PRINT SPC(15); "I. CHANGE TIME - DAYLIGHT TIME TO STANDARD OR U.S. RULES"
      CASE IS = 2
        PRINT SPC(15); "I. CHANGE TIME - U.S. RULES TO STANDARD OR DAYLIGHT TIME"
    END SELECT
   
    IF (UNITS$ = "METRIC") THEN
      PRINT SPC(15); "J. CHANGE UNITS - METRIC TO ENGLISH"
    ELSE
      PRINT SPC(15); "J. CHANGE UNITS - ENGLISH TO METRIC"
    END IF
    PRINT SPC(15); "K. NEW DESTINATION FOR PRINTED OUTPUT"
    PRINT SPC(15); "L. DISPLAY/PRINT ASTRONOMICAL FACTORS"
    PRINT SPC(15); "M. DISPLAY/PRINT CONSTITUENT FACTORS"
    PRINT SPC(15); "N. SHELL TO DOS - TYPE 'EXIT' TO RETURN"
    PRINT SPC(15); "O. FIND EXTREME HIGH, LOW, RANGE"
    PRINT SPC(15); "Q. QUIT PROGRAM"
    PRINT
    
    PRINT SPC(15); : INPUT ; "SELECTION = ", ANS$
    ANS$ = UCASE$(LEFT$(ANS$, 1))
    SELECT CASE ANS$
      CASE "A": CALL HILO
      CASE "B": CALL HRLYHTS
      CASE "C": CALL PLOT2
      CASE "D": CALL HTDMND
      CASE "E": CALL FILEIN(1): CALL PRNOTES: CALL EQUARG
      CASE "F": CLS : CALL PRTHDR(2, 0): CALL DATEIN: CALL MAKHDR: CALL PRTHDR(4, 0): CALL UPDATE: CALL EQUARG
      CASE "G": CALL DEFLSTA
      CASE "H": CALL TCMAIN: CALL UPDATE: CALL EQUARG
      CASE "I": CALL CONTUNTS
      CASE "J": CALL CONVUNTS
      CASE "K": CALL OUTFILE
      CASE "L": CALL PRASTRO
      CASE "M": CALL PRCONST
      CASE "N": SHELL
      CASE "O": CALL HHILLO
      CASE "Q": END
    END SELECT
  LOOP
END SUB 'MENU ==========================================================

SUB OUTFILE
  CLS
  CALL PRTHDR(1, 0)
  LOCATE 10, 15
  INPUT "SEND PRINTED OUTPUT TO PRINTER OR FILE (P/F) ? ", ANS$
  ANS$ = UCASE$(LEFT$(ANS$, 1))
  LOCATE 12, 15
  ITAH = 0                                             '4 OUTPUTS/LINE
  IF (ANS$ = "F") THEN
    INPUT "FILE NAME = ", TXTFILE$
    LOCATE 14, 15
    INPUT "PRINT 1 OR 4 OUTPUTS PER LINE (1/4) "; ANS$
    IF (ANS$ = "1") THEN ITAH = 2
  ELSE
    PRINT "ENTER PRINTER NUMBER [1, 2 OR 3] AND PRESS 'ENTER'"
    LOCATE 14, 15
    PRNO$ = "1"
    PRINT "PRINTER = LPT";
    CALL MODSTRNG(PRNO$)
    TXTFILE$ = "LPT" + PRNO$
  END IF
  CLOSE #3
  OPEN TXTFILE$ FOR OUTPUT AS #3
END SUB 'OUTFILE =======================================================

SUB PLOT2
  'ESCAPE CODES COMMENTED OUT 1994DEC18
  'PLOT HEIGHTS OR CURRENTS ------------------------------------------
  CLS : CALL PRTHDR(4, 0)
  PRINT : PRINT
  PRINT SPC(15); "PRINT PLOT OF "; PARAMS$; " (Y/N) ?  "; : INPUT "", ANS$
  ANS$ = UCASE$(LEFT$(ANS$, 1))
  IF (ANS$ = "Y") THEN IPR = 1 ELSE IPR = 0
  'IF (IPR = 1) THEN
    'PRINT #3, CHR$(27); CHR$(116); CHR$(1)          'EPSONS TO IBM GRAPHICS
    'PRINT #3, CHR$(28); CHR$(73); CHR$(49)          'NEC PINWRITERS TO IBM
    'PRINT #3, CHR$(27); CHR$(40); CHR$(49); CHR$(48); CHR$(85) 'HP, OKI TO PC-8
    'PRINT #3, CHR$(27); CHR$(79)                    'CANCEL SKIP PERFORATION
  'END IF

  PRINT : PRINT SPC(15); "TIME INTERVAL IN HOURS (HH.HH) = "; : INPUT "", DHRS
  IF (DHRS <= 0) THEN DHRS = .5
  XSTR = .5 * DHRS
  NSTR = INT(XSTR)
  NSTR$ = STR$(NSTR)
  IF (LEN(NSTR$) = 2) THEN MID$(NSTR$, 1, 1) = "0"
  XSTR = 60 * (XSTR - NSTR)
  MSTR$ = STR$(INT(XSTR))
  IF (LEN(MSTR$) = 2) THEN MID$(MSTR$, 1, 1) = "0"
  XSTR = 60 * (XSTR - INT(XSTR))
  LSTR$ = STR$(INT(XSTR))
  IF (LEN(LSTR$) = 2) THEN MID$(LSTR$, 1, 1) = "0"
  SSTR$ = RIGHT$(NSTR$, 2) + ":" + RIGHT$(MSTR$, 2) + ":" + RIGHT$(LSTR$, 2)

  CLS
  LOCATE 25, 10: PRINT "TYPE 'Q' OR 'Esc' TO QUIT, ANY OTHER KEY TO CONTINUE."; : LOCATE 1, 1
  CALL PRTHDR(4, IPR)
  PRINT PARAMS$; " IN "; XUNITS$;
  PRINT USING "  -  TIME INTERVAL ##.## HOURS STARTING AT "; DHRS;
  PRINT SSTR$
  PRINT
  IF (IPR > 0) THEN
    PRINT #3, PARAMS$; " IN "; XUNITS$;
    PRINT #3, USING "  -  TIME INTERVAL ##.## HOURS STARTING AT "; DHRS;
    PRINT #3, USING "\\"; RIGHT$(NSTR$, 2); RIGHT$(MSTR$, 2)
    PRINT #3, ""
  END IF
  
  DEL = DELFRC(2 * SMAMP)                       'SET GRID LINE INTERVAL
  NDEL = 1 + INT((SMAMP - Z0) / DEL) + INT((SMAMP + Z0) / DEL)
                                                'NUMBER OF INTERVALS IN RANGE
  MDEL = INT(68 / NDEL)                         'GRID LINE SPACING IN CHARS
  SCALE = MDEL / DEL                            'HORIZONTAL SCALE
  HMIN = DEL * INT((Z0 - SMAMP) / DEL)          'HEIGHT AT MINIMUM GRID LINE

  LINIMH$ = STRING$(80, " ")                    'SET UP IMAGES OF LINES
  LINIM0$ = STRING$(80, " "): MID$(LINIM0$, 9, 1) = CHR$(179): MID$(LINIM0$, 79, 1) = CHR$(179)
  LINIM1$ = STRING$(8, " ") + STRING$(71, CHR$(196)): MID$(LINIM1$, 9, 1) = CHR$(195): MID$(LINIM1$, 79, 1) = CHR$(180)
  LINIMS$ = STRING$(8, " ") + STRING$(71, CHR$(196)): MID$(LINIMS$, 9, 1) = CHR$(218): MID$(LINIMS$, 79, 1) = CHR$(191)
  LINIME$ = STRING$(8, " ") + STRING$(71, CHR$(196)): MID$(LINIME$, 9, 1) = CHR$(192): MID$(LINIME$, 79, 1) = CHR$(217)
  FOR I = 1 TO NDEL + 1
    H! = CSNG(HMIN + (I - 1) * DEL)
    IF (ABS(H!) < .0001) THEN H! = 0
    NHOR = 9 + (I - 1) * MDEL
    IF (NHOR > 8 AND NHOR < 78) THEN MID$(LINIMH$, NHOR - 1, 4) = RIGHT$(STR$(H!), 4)
    IF (NHOR > 9 AND NHOR < 79) THEN
      MID$(LINIM0$, NHOR, 1) = CHR$(179)
      MID$(LINIM1$, NHOR, 1) = CHR$(197)
      MID$(LINIMS$, NHOR, 1) = CHR$(194)
      MID$(LINIME$, NHOR, 1) = CHR$(193)
    END IF
  NEXT I
  NZERO = INT(9 + SCALE * (0 - HMIN) + .5)
  IF (NZERO >= 9) THEN                               'ZERO NOT OFF SCALE
    MID$(LINIM0$, NZERO, 1) = CHR$(186)              'DOUBLE LINE FOR ZERO
    MID$(LINIM1$, NZERO, 1) = CHR$(215)
    MID$(LINIMS$, NZERO, 1) = CHR$(210)
    MID$(LINIME$, NZERO, 1) = CHR$(208)
  END IF
 
  MID$(LINIMH$, 1, 5) = LEFT$(STRDATE.DATESTR, 5)
  PRINT LINIMH$: IF (IPR = 1) THEN PRINT #3, LINIMH$
 
  LINIM$ = LINIMS$                                 'SET UP FIRST LINE
  MID$(LINIM$, 1, 5) = MID$(STRDATE.DATESTR, 7, 5)
  MID$(LINIM$, 7, 2) = STRDATE.DOW
 
  NLINES = 10                                      'COUNT OF LINES ON SCREEN
  TT = .5 * DHRS
  CALL HANDDH                                      'EVALUATE HEIGHT/CURR
  NHCL2 = INT(9 + SCALE * (HT(1) - HMIN) + .5)
  MID$(LINIM$, NHCL2, 1) = CHR$(220)
  PRINT LINIM$: IF (IPR = 1) THEN PRINT #3, LINIM$

  NEWDATE = STRDATE
  TT = 1.5 * DHRS                                  'FIRST TIME AT NEXT PRINT
  DO
    TREM = TT - 24 * INT((TT + DHRS) / 24)         'TT MOD 24, -D TO 24-D
    NHRM = INT(TREM + DHRS)
    TRM6 = TT - 6 * INT((TT + DHRS) / 6)           'TT MOD  6, -D TO  6-D
    IF (ABS(TREM - (24 - 2 * DHRS)) < DHRS) THEN    'TT  24 - 2*DHRS
      NEWDATE.DA = NEWDATE.DA + 1
      CALL YMD2REC(NEWDATE)
      MID$(LINIMH$, 1, 5) = LEFT$(NEWDATE.DATESTR, 5)
      LINIM$ = LINIMH$
    ELSEIF (ABS(TREM) <= DHRS) THEN                 'TT  0000
      LINIM$ = LINIM1$
      MID$(LINIM$, 1, 5) = MID$(NEWDATE.DATESTR, 7, 5)
      MID$(LINIM$, 7, 2) = NEWDATE.DOW
    ELSEIF (ABS(TRM6) < DHRS) THEN
      LINIM$ = LINIM1$
      MID$(LINIM$, 5, 4) = RIGHT$(STR$(NHRM), 2) + "00"
    ELSE LINIM$ = LINIM0$
    END IF
   
    CALL HANDDH                                     'EVALUATE HEIGHT/CURR
    NHCL1 = INT(9 + SCALE * (HT(1) - HMIN) + .5)
    IF ((NHCL1 <= LEN(LINIM$)) AND (NHCL1 > 0)) THEN MID$(LINIM$, NHCL1, 1) = CHR$(223)
    TT = TT + DHRS
    CALL HANDDH                                     'EVALUATE HEIGHT/CURR
    NHCL2 = INT(9 + SCALE * (HT(1) - HMIN) + .5)
    IF ((NHCL2 <= LEN(LINIM$)) AND (NHCL2 > 0)) THEN
      IF (NHCL2 = NHCL1) THEN
        MID$(LINIM$, NHCL2, 1) = CHR$(219)
      ELSE
        MID$(LINIM$, NHCL2, 1) = CHR$(220)
      END IF
    END IF
    PRINT LINIM$: IF (IPR = 1) THEN PRINT #3, LINIM$
    NLINES = NLINES + 1
   
    IF (IPR = 0 AND NLINES = 24) THEN         'CHECK FOR FULL SCREEN
      DO
        INK$ = INKEY$
      LOOP UNTIL (INK$ <> "")
      INK$ = UCASE$(LEFT$(INK$, 1))
      IF (INK$ = "Q" OR ASC(INK$) = 27) THEN EXIT SUB
      NLINES = 2
    END IF
   
    TT = TT + DHRS
   
    INK$ = INKEY$
    IF (UCASE$(INK$) = "Q") THEN EXIT SUB

  LOOP WHILE (TT < 24 * (ENDDATE.DNOJ - STRDATE.DNOJ + 1))

  PRINT LINIME$: IF (IPR > 0) THEN PRINT #3, LINIME$
  LOCATE 25, 1: PRINT SPC(79);
  LOCATE 25, 27: PRINT "PRESS ANY KEY TO CONTINUE.";
  WHILE (INKEY$ = ""): WEND
  IF (IPR = 1) THEN PRINT #3, CHR$(12): ' PRINT #3, CHR$(27); CHR$(78); CHR$(6);
END SUB 'PLOT2 =========================================================

REM $STATIC
SUB PRNOTES
  'PRINTS NOTES FOR NEW STATION
  IF (NOTES$ <> "") THEN
    CLS
    FOR I = 1 TO 4
      PRINT HEADER$(I)
      PRINT
    NEXT I
    PRINT NOTES$
    LOCATE 25, 20
    PRINT "PRESS ANY KEY TO CONTINUE";
    WHILE (INKEY$ = ""): WEND
    CLS
  END IF
END SUB 'PRNOTES ==========================================================

REM $DYNAMIC
SUB PRTANDH (TX, DUMDATE AS DATEREC, ITAHX) STATIC
  'PRINT TIME AND HEIGHT ---------------------------------------------

  'IF ITAHX =-1, INITIAL CALL, PRINT DATE ONLY?
  '         = 0, PRINT TIME & HEIGHT
  '         = 1, PRINT TIME ONLY
  '         = 2, PRINT DATE, TIME AND HEIGHT
 
  IF (TX = 0 AND ITAHX = -1) THEN
    PRINT NEWDATE.DATESTR; " "; NEWDATE.DOW;                       'PRINT DATE
    IF (IPR > 0) THEN PRINT #3, NEWDATE.DATESTR; " "; NEWDATE.DOW; 'PRINT DATE
    EXIT SUB
  END IF

  TPR = TX - 24 * (DUMDATE.DNOJ - STRDATE.DNOJ) + .00833 'ROUND TO NEAREST MINUTE
 
  IF (TPR > 24) THEN                                      'HOUR OVERFLOW
    TPR = TPR - 24
    DUMDATE.DA = DUMDATE.DA + 1
    CALL YMD2REC(DUMDATE)
    IF (ITAHX < 2) THEN                                   'PRINT FOUR/LINE
      IF (DUMDATE.DOW = "SU") THEN
        PRINT
        IF (IPR > 0) THEN PRINT #3, ""
      END IF
      PRINT : PRINT DUMDATE.DATESTR; : PRINT " "; DUMDATE.DOW;
      IF (IPR > 0) THEN PRINT #3, "": PRINT #3, DUMDATE.DATESTR; : PRINT #3, " "; DUMDATE.DOW;
      NHILO = 0                   'COUNT OF HI'S & LO'S ON LINE
    END IF
  END IF

  SELECT CASE ITRULE
    CASE IS = 0                                     'ITRULE = 0 - STANDARD TIME
      IF (STTDST = 1) THEN                          'DST - RESET
        CALL TTOGGLE(DUMDATE, TPR)
      END IF 'STTDST
    CASE IS = 1                                     'ITRULE = 1 - DAYLIGHT TIME
      IF (STTDST = 0) THEN                          'STT - RESET
        CALL TTOGGLE(DUMDATE, TPR)
      END IF 'STTDST
    CASE IS = 2                                     'ITRULE = 2 - U.S. RULES
      SELECT CASE DUMDATE.TFLAG
        CASE IS = 0                                 'TFLAG = 0  STT
          IF (STTDST = 1) THEN                      'DST - RESET
            CALL TTOGGLE(DUMDATE, TPR)
          END IF 'STTDST
        CASE IS = 1                                 'TFLAG=1 DST
          IF (STTDST = 0) THEN                      'SST - RESET
            CALL TTOGGLE(DUMDATE, TPR)
          END IF 'STTDST
        CASE IS = 2                                  'FIRST SUN APR
          IF (TPR < 2) THEN                          'STILL STT
            IF (STTDST = 1) THEN                     'DST - RESET
              CALL TTOGGLE(DUMDATE, TPR)
            END IF 'STTDST
          ELSE                                       'TPR>2 - DST
            IF (STTDST = 0) THEN                     'STT - RESET
              CALL TTOGGLE(DUMDATE, TPR)
            END IF 'STTDST
          END IF 'TPR
        CASE IS = 3                                  'LAST SUN OCT
          IF (TPR < 2) THEN                          'TPR < 2 - STILL DST
            IF (STTDST = 0) THEN                     'STT - RESET
              CALL TTOGGLE(DUMDATE, TPR)
            END IF 'STTDST
          ELSE                                       'TPR >= 2 - STT
            IF (STTDST = 1) THEN                     'DST - RESET
              CALL TTOGGLE(DUMDATE, TPR)
            END IF 'STTDST
          END IF 'TPR
      END SELECT 'DUMDATE.TFLAG
  END SELECT 'ITRULE
 
  TPH$ = STR$(INT(TPR)): TPM$ = STR$(INT(60 * (TPR - INT(TPR))))
  IF (LEN(TPH$) = 2) THEN TPH$ = "0" + RIGHT$(TPH$, 1) ELSE TPH$ = RIGHT$(TPH$, 2)
  IF (LEN(TPM$) = 2) THEN TPM$ = "0" + RIGHT$(TPM$, 1) ELSE TPM$ = RIGHT$(TPM$, 2)
 
  SELECT CASE KTIDTYP
    CASE 0, 1, 2
      SPACER$ = "     "
    CASE 3
      SPACER$ = "   "
  END SELECT

  IF (ITAH = 2) THEN
    PRINT DUMDATE.DATESTR;
    PRINT " " + TPH$ + TPM$ + " ";
    PRINT USING "####.##"; HT(1)
    IF (IPR > 0) THEN
      PRINT #3, DUMDATE.DATESTR;
      PRINT #3, " " + TPH$ + TPM$ + " ";
      PRINT #3, USING "####.##"; HT(1)
    END IF
    EXIT SUB
  END IF
       
  NHILO = NHILO + 1
  IF ((NHILO > 4) AND (NHILO MOD 4 = 1)) THEN PRINT : PRINT "              ";
  PRINT SPACER$ + TPH$ + TPM$;
  IF (ITAHX = 0) THEN
    IF (UNITS$ = "METRIC") THEN
      PRINT USING "###.##"; HT(1);
    ELSE
      PRINT USING "####.#"; HT(1);
    END IF
  END IF
                                    
  IF (IPR > 0) THEN
    IF ((NHILO > 4) AND (NHILO MOD 4 = 1)) THEN PRINT #3, "": PRINT #3, "              ";
    PRINT #3, SPACER$ + TPH$ + TPM$;
    IF (ITAHX = 0) THEN
      IF (UNITS$ = "METRIC") THEN
        PRINT #3, USING "###.##"; HT(1);
      ELSE
        PRINT #3, USING "####.#"; HT(1);
      END IF
    END IF
  END IF

  IF (KTIDTYP = 3) THEN
    PRINT USING "####"; HT(3);
    IF (IPR > 0) THEN PRINT #3, USING "####"; HT(3);
  END IF
END SUB 'PRTANDH =======================================================

SUB PRTHDR (ILN, IPH)
'PRINT ILN LINES OF HEADER$

' IPH = 0 - PRINT TO SCREEN ONLY
'     = 1 - PRINT TO PRINTER ONLY
'     = 2 - PRINT TO BOTH

  SELECT CASE IPH
  CASE IS = 0                                      'OUTPUT TO SCREEN
    CLS
    FOR I = 1 TO ILN
    IF (HEADER$(I) <> "") THEN
        PRINT HEADER$(I)
        PRINT
      END IF
    NEXT I
 
  CASE IS = 1                                      'OUTPUT TO PRINTER
    FOR I = 1 TO ILN
      IF (HEADER$(I) <> "") THEN
        PRINT #3, HEADER$(I), CHR$(10), CHR$(13)
        PRINT #3, ""
      END IF
    NEXT I
 
  CASE IS > 1                                      'OUTPUT TO BOTH
    FOR I = 1 TO ILN
      CLS
      IF (HEADER$(I) <> "") THEN
        PRINT HEADER$(I)
        PRINT
        PRINT #3, HEADER$(I), CHR$(10), CHR$(13)
        PRINT #3, ""
      END IF
    NEXT I
  END SELECT
END SUB 'PRTHDR ========================================================

SUB TITLSCRN
'TITLE SCREEN ---------------------------------------------------------------
                                                 
  DIM TITL$(9)
 
  TITL$(1) = "    ͻ"
  TITL$(2) = "                                                                          "
  TITL$(3) = "                                    "
  TITL$(4) = "                                                        "
  TITL$(5) = "                                                "
  TITL$(6) = "                                                        "
  TITL$(7) = "                                          "
  TITL$(8) = "                                                                          "
  TITL$(9) = "    ͼ"
 
  SCREEN 0, 0, 0: COLOR 14, 1, 1
  CLS
  FOR I = 1 TO 9
    PRINT TITL$(I)
  NEXT I
 
  PRINT SPC(27); "   Version 4.07"
  PRINT SPC(27); " Copyright (c) 1999": PRINT
  PRINT SPC(27); " NAUTICAL SHAREWARE"
  PRINT SPC(27); " 32 Barney Hill Road"
  PRINT SPC(27); "Wayland, MA 01778-3602"
  PRINT SPC(27); "   (508)-358-7938"
  PRINT SPC(27); "epwallnr@world.std.com"
  PRINT
  PRINT SPC(5); "This program may be freely copied without alteration and passed on for "
  PRINT SPC(5); "trial use for non-commercial purposes. This is a user supported "
  PRINT SPC(5); "Shareware program. If you continue to use it, a registration fee of $15 "
  PRINT SPC(5); "must be paid, which will assure that you have the latest release."
  PRINT SPC(5); "The author assumes no responsibility for the accuracy of the program or "
  PRINT SPC(5); "its predictions.";

  LOCATE 25, 28: PRINT "PRESS ANY KEY TO CONTINUE.";
  WHILE (INKEY$ = ""): WEND'---------------------------------------------
 
  CLS
  LOCATE 5, 35
  PRINT "WARNING"
  PRINT
  PRINT "  While effort has been made to obtain the best data publicly available, in "
  PRINT "  no case can the data or predictions be considered official or to have any "
  PRINT "  legal standing. The data and predictions are used at your own risk and "
  PRINT "  should be done so with caution. "
  PRINT ""
  PRINT "  The data for U.S. stations are derived from National Ocean Service documents."
  PRINT "  Data for foreign stations is from various sources and may be incomplete, "
  PRINT "  obsolete, or erroneus and should be checked against official tables or the"
  PRINT "  ocean. Reference levels also vary on the charts of various countries. Read"
  PRINT "  TIDES4.DOC for additional considerations. Station data is provided for non-"
  PRINT "  commercial use only."

  LOCATE 25, 28: PRINT "PRESS ANY KEY TO CONTINUE.";
  WHILE (INKEY$ = ""): WEND
 
  'PRINT NOTICE -----------------------------------------------------------
  CLS
  LOCATE 5, 35
  PRINT "NOTICE"
  PRINT
  PRINT "  The predicted tidal heights should be considered those expected under average"
  PRINT "  weather conditions. The mariner should be cautioned that during times when"
  PRINT "  weather conditions differ from what is considered average for the area,"
  PRINT "  corresponding differences between predicted levels and those actually "
  PRINT "  observed will be noted. Generally, prolonged onshore winds or a low "
  PRINT "  barometric pressure can produce higher levels than predicted, while the "
  PRINT "  opposite can result in lower levels than those predicted."
  PRINT
  PRINT "  During times of storm surges or when extreme weather conditions are imminent,"
  PRINT "  it would be prudent for the mariner to keep closely advised by local weather"
  PRINT "  forecasts as they relate to the effects upon the tide levels."
  PRINT "                                             (From the NOS Tide Tables)"
  LOCATE 25, 28: PRINT "PRESS ANY KEY TO CONTINUE.";
  WHILE (INKEY$ = ""): WEND'---------------------------------------------
 
END SUB 'TITLSCRN ======================================================

REM $STATIC
SUB TTOGGLE (DUMDATE AS DATEREC, TPR)
'TOGGLES BETWEEN STANDARD AND DAYLIGHT TIME
  STTDST = (STTDST + 1) MOD 2
  TT = TT - 1 + 2 * STTDST                       'FALL BACK OR SPRING FORWARD
  TPR = TPR - 1 + 2 * STTDST                     ' "    "  "    "      "
  CALL MAKHDR
  PRINT : PRINT
  PRINT HEADER$(3)
  PRINT
  PRINT DUMDATE.DATESTR; : PRINT " "; DUMDATE.DOW;
  IF (IPR > 0) THEN
    PRINT #3, "": PRINT #3, ""
    PRINT #3, HEADER$(3)
    PRINT #3, ""
    PRINT #3, "": PRINT #3, DUMDATE.DATESTR; : PRINT #3, " "; DUMDATE.DOW;
  END IF 'IPR
END SUB

