DECLARE FUNCTION ATAN2D# (S#, C#)
DECLARE FUNCTION ATAN2# (S#, C#)
DECLARE FUNCTION ANGRDD# (X#)
DECLARE FUNCTION ANGRDR# (X#)
DECLARE FUNCTION ASIND# (X#)
DECLARE FUNCTION COSD# (X#)
DECLARE FUNCTION SIND# (X#)
CONST PI = 3.141592653589793#, RDPD = PI / 180#, DPRD = 1# / RDPD

DEFINT I-N
DEFDBL A-H, O-Z
FUNCTION ANGRDD (X) STATIC
  'REDUCES ANGLES 0 TO 360
  ANGRDD = X - 360# * INT(X / 360#)
END FUNCTION

FUNCTION ANGRDR (X) STATIC
  'REDUCES ANGLES 0 TO 2 PI
  TWOPI = 2# * PI
  ANGRDR = X - TWOPI * INT(X / TWOPI)
END FUNCTION

FUNCTION ASIND (S) STATIC
  'ARCSINE IN DEGREES
  ASIND = ANGRDD(DPRD * ATN(S / SQR(1 - S * S)))
END FUNCTION

FUNCTION ATAN2 (S, C) STATIC
  'TWO ARGUMENT ARC TANGENT - RADIANS
  SELECT CASE C
    CASE IS > 0
      ATAN2 = ATN(S / C)
    CASE IS < 0
      ATAN2 = ATN(S / C) + PI
    CASE 0
      ATAN2 = SGN(S) * PI / 2#
  END SELECT
END FUNCTION

FUNCTION ATAN2D (S, C) STATIC
  'TWO ARGUMENT ARC TANGENT - DEGREES
  SELECT CASE C
  CASE IS > 0
    ATAN2D = ATN(S / C) * DPRD
  CASE IS < 0
    ATAN2D = ATN(S / C) * DPRD + 180#
  CASE 0
    ATAN2D = SGN(S) * 90#
  END SELECT
END FUNCTION

FUNCTION COSD (X) STATIC
  'COSINE OF ANGLE IN DEGREES
  COSD = COS(X * RDPD)
END FUNCTION

FUNCTION SIND (X) STATIC
  'SINE OF ANGLE IN DEGREES
  SIND = SIN(X * RDPD)
END FUNCTION

